Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/interface_surf.F90
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/interface_surf.F90	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/interface_surf.F90	(revision 633)
@@ -64,5 +64,9 @@
       & tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef, &
       & precip_rain, precip_snow, sollw, sollwdown, swnet, swdown, &
-      & fder, taux, tauy, rugos, rugoro, &
+      & fder, taux, tauy, &
+! -- LOOP
+      & windsp, &
+! -- LOOP
+      & rugos, rugoro, &
       & albedo, snow, qsurf, &
       & tsurf, p1lay, ps, radsol, &
@@ -127,4 +131,7 @@
 !   fder         derivee des flux (pour le couplage)
 !   taux, tauy   tension de vents
+! -- LOOP
+!   windsp       module du vent a 10m
+! -- LOOP
 !   rugos        rugosite
 !   zmasq        masque terre/ocean
@@ -175,4 +182,7 @@
   real, dimension(klon), intent(IN) :: zmasq
   real, dimension(klon), intent(IN) :: taux, tauy, rugos, rugoro
+! -- LOOP
+  real, dimension(klon), intent(IN) :: windsp
+! -- LOOP
   character (len = 6)  :: ocean
   integer              :: npas, nexca ! nombre et pas de temps couplage
@@ -300,4 +310,8 @@
         call abort_gcm(modname,abort_message,1)
       endif
+!cym      
+      run_off=0.0
+!cym
+
 !!$PB
       ALLOCATE (tmp_rriv(iim,jjm+1), stat=error)
@@ -316,4 +330,7 @@
         call abort_gcm(modname,abort_message,1)
       endif
+      tmp_rriv = 0.0
+      tmp_rcoa = 0.0
+      tmp_rlic = 0.0
 
 !!$
@@ -440,6 +457,11 @@
       & ocean, npas, nexca, debut, lafin, &
       & swdown, sollw, precip_rain, precip_snow, evap, tsurf, &
-      & fluxlat, fluxsens, fder, albedo, taux, tauy, zmasq, &
-      & tsurf_new, alb_new, pctsrf_new)
+      & fluxlat, fluxsens, fder, albedo, taux, tauy, &
+! -- LOOP
+      & windsp, &
+! -- LOOP
+      & zmasq, &
+      & tsurf_new, alb_new, &
+      & pctsrf_new)
 
 !    else if (ocean == 'slab  ') then
@@ -494,6 +516,11 @@
       & ocean, npas, nexca, debut, lafin, &
       & swdown, sollw, precip_rain, precip_snow, evap, tsurf, &
-      & fluxlat, fluxsens, fder, albedo, taux, tauy, zmasq, &
-      & tsurf_new, alb_new, pctsrf_new)
+      & fluxlat, fluxsens, fder, albedo, taux, tauy, &
+! -- LOOP
+      & windsp, &
+! -- LOOP
+      & zmasq, &
+      & tsurf_new, alb_new, &
+      & pctsrf_new)
 
 !    else if (ocean == 'slab  ') then
@@ -545,6 +572,11 @@
       & ocean, npas, nexca, debut, lafin, &
       & swdown, sollw, precip_rain, precip_snow, evap, tsurf, &
-      & fluxlat, fluxsens, fder, albedo, taux, tauy, zmasq, &
-      & tsurf_new, alb_new, pctsrf_new)
+      & fluxlat, fluxsens, fder, albedo, taux, tauy, &
+! -- LOOP
+      & windsp, &
+! -- LOOP
+      & zmasq, &
+      & tsurf_new, alb_new, &
+      & pctsrf_new)
 
       tsurf_temp = tsurf_new
@@ -640,6 +672,11 @@
       & ocean, npas, nexca, debut, lafin, &
       & swdown, sollw, precip_rain, precip_snow, evap, tsurf, &
-      & fluxlat, fluxsens, fder, albedo, taux, tauy, zmasq, &
-      & tsurf_new, alb_new, pctsrf_new)
+      & fluxlat, fluxsens, fder, albedo, taux, tauy, &
+! -- LOOP
+      & windsp, &
+! -- LOOP
+      & zmasq, &
+      & tsurf_new, alb_new, &
+      & pctsrf_new)
 
 !    else if (ocean == 'slab  ') then
@@ -1194,6 +1231,11 @@
       & ocean, npas, nexca, debut, lafin, &
       & swdown, lwdown, precip_rain, precip_snow, evap, tsurf, &
-      & fluxlat, fluxsens, fder, albsol, taux, tauy, zmasq, &
-      & tsurf_new, alb_new, pctsrf_new)
+      & fluxlat, fluxsens, fder, albsol, taux, tauy, &
+! -- LOOP
+      & windsp, &
+! -- LOOP
+      & zmasq, &
+      & tsurf_new, alb_new, &
+      & pctsrf_new)
 
 ! Cette routine sert d'interface entre le modele atmospherique et un 
@@ -1238,4 +1280,7 @@
 !   taux         tension de vent en x
 !   tauy         tension de vent en y
+! -- LOOP
+!    windsp       module du vent a 10m
+! -- LOOP
 !   nexca        frequence de couplage
 !   zmasq        masque terre/ocean
@@ -1248,5 +1293,8 @@
 !   alb_ice      albedo de la glace
 !
-
+#ifdef CPP_PSMILE  
+  USE oasis
+  integer :: il_time_secs !time in seconds
+#endif
 
 ! Parametres d'entree
@@ -1265,4 +1313,7 @@
   real, dimension(klon), intent(IN) :: precip_rain, precip_snow
   real, dimension(klon), intent(IN) :: tsurf, fder, albsol, taux, tauy
+! -- LOOP
+   real, dimension(klon), intent(IN) :: windsp
+! -- LOOP
   INTEGER              :: nexca, npas, kstep
   real, dimension(klon), intent(IN) :: zmasq
@@ -1277,4 +1328,7 @@
 ! Variables locales
   integer                    :: j, error, sum_error, ig, cpl_index,i
+! -- LOOP
+  INTEGER :: nsrf
+! -- LOOP
   character (len = 20) :: modname = 'interfoce_cpl'
   character (len = 80) :: abort_message
@@ -1284,4 +1338,7 @@
   real, allocatable, dimension(:,:),save :: cpl_snow, cpl_evap, cpl_tsol
   real, allocatable, dimension(:,:),save :: cpl_fder, cpl_albe, cpl_taux
+! -- LOOP
+  real, allocatable, dimension(:,:),save :: cpl_windsp
+! -- LOOP
   real, allocatable, dimension(:,:),save :: cpl_tauy
   REAL, ALLOCATABLE, DIMENSION(:,:),SAVE :: cpl_rriv, cpl_rcoa, cpl_rlic
@@ -1291,4 +1348,7 @@
   real, allocatable, dimension(:,:,:),save :: tmp_snow, tmp_evap, tmp_tsol
   real, allocatable, dimension(:,:,:),save :: tmp_fder, tmp_albe, tmp_taux
+! -- LOOP
+  real, allocatable, dimension(:,:,:),save :: tmp_windsp
+! -- LOOP
 !!$  real, allocatable, dimension(:,:,:),save :: tmp_tauy, tmp_rriv, tmp_rcoa
   REAL, ALLOCATABLE, DIMENSION(:,:,:),SAVE :: tmp_tauy
@@ -1298,4 +1358,7 @@
   REAL, DIMENSION(iim, jjm+1) :: wri_evap_sea, wri_rcoa, wri_rriv
   REAL, DIMENSION(iim, jjm+1) :: wri_rain, wri_snow, wri_taux, wri_tauy
+! -- LOOP
+   REAL, DIMENSION(iim, jjm+1) :: wri_windsp
+! -- LOOP
   REAL, DIMENSION(iim, jjm+1) :: wri_calv
   REAL, DIMENSION(iim, jjm+1) :: wri_tauxx, wri_tauyy, wri_tauzz
@@ -1327,8 +1390,14 @@
   INTEGER :: ndexct(iim*(jjm+1)),ndexcs(iim*(jjm+1))
   REAL :: zx_lon(iim,jjm+1), zx_lat(iim,jjm+1), zjulian
-  integer :: idayref, itau_w
+  INTEGER,save :: idayref
+!med  integer :: itau_w
+  integer,save :: itau_w
+! -- LOOP
+  integer :: nb_interf_cpl
+! -- LOOP
 #include "param_cou.h"
 #include "inc_cpl.h"
 #include "temps.inc"
+#include "iniprint.h"
 !
 ! Initialisation
@@ -1363,4 +1432,7 @@
     allocate(cpl_albe(klon,2), stat = error); sum_error = sum_error + error
     allocate(cpl_taux(klon,2), stat = error); sum_error = sum_error + error
+! -- LOOP
+     allocate(cpl_windsp(klon,2), stat = error); sum_error = sum_error + error
+! -- LOOP
     allocate(cpl_tauy(klon,2), stat = error); sum_error = sum_error + error
     ALLOCATE(cpl_rriv(iim,jjm+1), stat=error); sum_error = sum_error + error
@@ -1380,4 +1452,7 @@
     cpl_evap = 0.; cpl_tsol = 0.; cpl_fder = 0.; cpl_albe = 0.
     cpl_taux = 0.; cpl_tauy = 0.; cpl_rriv = 0.; cpl_rcoa = 0.; cpl_rlic = 0.
+! -- LOOP
+     cpl_windsp = 0.
+! -- LOOP
 
     sum_error = 0
@@ -1392,6 +1467,11 @@
 !
     idtime = int(dtime)
-    call inicma(npas , nexca, idtime,(jjm+1)*iim)
-
+#ifdef CPP_COUPLE
+#ifdef CPP_PSMILE
+    CALL inicma(iim, (jjm+1))
+#else
+   call inicma(npas , nexca, idtime,(jjm+1)*iim)
+#endif
+#endif
 !
 ! initialisation sorties netcdf
@@ -1454,8 +1534,15 @@
 
 ! calcul des fluxs a passer
-
+! -- LOOP
+  nb_interf_cpl = nb_interf_cpl + 1  
+  if (check) write(lunout,*)'passage dans interface_surf.F90 :  ',nb_interf_cpl 
+! -- LOOP
   cpl_index = 1
   if (nisurf == is_sic) cpl_index = 2
   if (cumul) then
+! -- LOOP
+      if (check) write(lunout,*)'passage dans cumul '
+      if (check) write(lunout,*)'valeur de cpl_index ', cpl_index 
+! -- LOOP  
     if (check) write(*,*) modname, 'cumul des champs'
     do ig = 1, knon
@@ -1481,4 +1568,10 @@
       cpl_tauy(ig,cpl_index) = cpl_tauy(ig,cpl_index) &
        &                          + tauy(ig)        / FLOAT(nexca)
+! -- LOOP
+      IF (cpl_index .EQ. 1) THEN
+      cpl_windsp(ig,cpl_index) = cpl_windsp(ig,cpl_index) &
+       &                          + windsp(ig)      / FLOAT(nexca) 
+      ENDIF
+! -- LOOP
     enddo
     IF (cpl_index .EQ. 1) THEN 
@@ -1497,6 +1590,14 @@
     if (nisurf == is_oce .and. .not. cumul) then
       if (check) write(*,*)'rentree fromcpl, itime-1 = ',itime-1
+#ifdef CPP_COUPLE
+#ifdef CPP_PSMILE
+      il_time_secs=(itime-1)*dtime
+      CALL fromcpl(il_time_secs, iim, (jjm+1),                           &
+     &        read_sst, read_sic, read_sit, read_alb_sic)
+#else
       call fromcpl(itime-1,(jjm+1)*iim,                                  &
      &        read_sst, read_sic, read_sit, read_alb_sic)
+#endif
+#endif
 !
 ! sorties NETCDF des champs recus
@@ -1584,4 +1685,7 @@
       allocate(tmp_taux(iim,jjm+1,2), stat=error); sum_error = sum_error + error
       allocate(tmp_tauy(iim,jjm+1,2), stat=error); sum_error = sum_error + error
+! -- LOOP
+       allocate(tmp_windsp(iim,jjm+1,2), stat=error); sum_error = sum_error + error
+! -- LOOP
 !!$      allocate(tmp_rriv(iim,jjm+1,2), stat=error); sum_error = sum_error + error
 !!$      allocate(tmp_rcoa(iim,jjm+1,2), stat=error); sum_error = sum_error + error
@@ -1606,4 +1710,7 @@
     call gath2cpl(cpl_albe(1,cpl_index), tmp_albe(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
     call gath2cpl(cpl_taux(1,cpl_index), tmp_taux(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
+! -- LOOP
+     call gath2cpl(cpl_windsp(1,cpl_index), tmp_windsp(1,1,cpl_index), klon, knon,iim,jjm,             knindex)
+! -- LOOP
     call gath2cpl(cpl_tauy(1,cpl_index), tmp_tauy(1,1,cpl_index), klon, knon,iim,jjm,                  knindex)
 
@@ -1614,4 +1721,7 @@
       wri_rain = 0.; wri_snow = 0.; wri_rcoa = 0.; wri_rriv = 0. 
       wri_taux = 0.; wri_tauy = 0.
+! -- LOOP
+       wri_windsp = 0.
+! -- LOOP      
       call gath2cpl(pctsrf(1,is_oce), tamp_srf(1,1,1), klon, klon, iim, jjm, tamp_ind)
       call gath2cpl(pctsrf(1,is_sic), tamp_srf(1,1,2), klon, klon, iim, jjm, tamp_ind)
@@ -1624,4 +1734,8 @@
       wri_evap_ice = tmp_evap(:,:,2)
       wri_evap_sea = tmp_evap(:,:,1)
+! -- LOOP
+       wri_windsp = tmp_windsp(:,:,1)
+! -- LOOP
+
 !!$PB
       wri_rriv = cpl_rriv(:,:)
@@ -1677,32 +1791,55 @@
 ! envoi au coupleur
 !
-      CALL histwrite(nidct,cl_writ(1),itau_w,wri_sol_ice,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(2),itau_w,wri_sol_sea,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(3),itau_w,wri_nsol_ice,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(4),itau_w,wri_nsol_sea,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(5),itau_w,wri_fder_ice,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(6),itau_w,wri_evap_ice,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(7),itau_w,wri_evap_sea,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(8),itau_w,wri_rain,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(9),itau_w,wri_snow,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(10),itau_w,wri_rcoa,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(11),itau_w,wri_rriv,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(12),itau_w,wri_calv,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(13),itau_w,wri_tauxx,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(14),itau_w,wri_tauyy,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(15),itau_w,wri_tauzz,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(16),itau_w,wri_tauxx,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(17),itau_w,wri_tauyy,iim*(jjm+1),ndexct)
-      CALL histwrite(nidct,cl_writ(18),itau_w,wri_tauzz,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(8),itau_w,wri_sol_ice,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(9),itau_w,wri_sol_sea,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(10),itau_w,wri_nsol_ice,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(11),itau_w,wri_nsol_sea,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(12),itau_w,wri_fder_ice,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(13),itau_w,wri_evap_ice,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(14),itau_w,wri_evap_sea,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(15),itau_w,wri_rain,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(16),itau_w,wri_snow,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(17),itau_w,wri_rcoa,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(18),itau_w,wri_rriv,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(19),itau_w,wri_calv,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(1),itau_w,wri_tauxx,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(2),itau_w,wri_tauyy,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(3),itau_w,wri_tauzz,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(4),itau_w,wri_tauxx,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(5),itau_w,wri_tauyy,iim*(jjm+1),ndexct)
+      CALL histwrite(nidct,cl_writ(6),itau_w,wri_tauzz,iim*(jjm+1),ndexct)
+! -- LOOP
+      CALL histwrite(nidct,cl_writ(7),itau_w,wri_windsp,iim*(jjm+1),ndexct)
+! -- LOOP
       CALL histsync(nidct)
 ! pas utile      IF (lafin) CALL histclo(nidct)
+#ifdef CPP_COUPLE
+#ifdef CPP_PSMILE
+      il_time_secs=(itime-1)*dtime
+
+      CALL intocpl(il_time_secs, iim, jjm+1, wri_sol_ice, wri_sol_sea, wri_nsol_ice,&
+      & wri_nsol_sea, wri_fder_ice, wri_evap_ice, wri_evap_sea, wri_rain, &
+      & wri_snow, wri_rcoa, wri_rriv, wri_calv, wri_tauxx, wri_tauyy,     &
+      & wri_tauzz, wri_tauxx, wri_tauyy, wri_tauzz,                       &
+! -- LOOP
+      & wri_windsp,lafin)
+! -- LOOP
+#else
       call intocpl(itime, (jjm+1)*iim, wri_sol_ice, wri_sol_sea, wri_nsol_ice,&
       & wri_nsol_sea, wri_fder_ice, wri_evap_ice, wri_evap_sea, wri_rain, &
       & wri_snow, wri_rcoa, wri_rriv, wri_calv, wri_tauxx, wri_tauyy,     &
-      & wri_tauzz, wri_tauxx, wri_tauyy, wri_tauzz,lafin )
+      & wri_tauzz, wri_tauxx, wri_tauyy, wri_tauzz,                       &
+! -- LOOP
+      & wri_windsp,lafin)
+! -- LOOP
+#endif
+#endif
 ! 
       cpl_sols = 0.; cpl_nsol = 0.; cpl_rain = 0.; cpl_snow = 0.
       cpl_evap = 0.; cpl_tsol = 0.; cpl_fder = 0.; cpl_albe = 0.
       cpl_taux = 0.; cpl_tauy = 0.; cpl_rriv = 0.; cpl_rcoa = 0.; cpl_rlic = 0.
+! -- LOOP
+      cpl_windsp = 0.
+! -- LOOP
 !
 ! deallocation memoire variables temporaires
@@ -1719,4 +1856,7 @@
       deallocate(tmp_taux, stat=error); sum_error = sum_error + error
       deallocate(tmp_tauy, stat=error); sum_error = sum_error + error
+! -- LOOP
+      deallocate(tmp_windsp, stat=error); sum_error = sum_error + error
+! -- LOOP
 !!$PB
 !!$      deallocate(tmp_rriv, stat=error); sum_error = sum_error + error
@@ -2582,5 +2722,5 @@
 
 #include "YOETHF.inc"
-#include "FCTTRE.inc"
+!rv#include "FCTTRE.inc"
 #include "indicesol.inc"
 !IM cf JLD
@@ -2639,4 +2779,5 @@
   logical,save         :: first = .true.,second=.false.
   real                 :: coeff_rel
+#include "FCTTRE.inc"
 
 
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/iophy.F90
===================================================================
--- LMDZ4/branches/LMDZ4_par_0/libf/phylmd/iophy.F90	(revision 633)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/iophy.F90	(revision 633)
@@ -0,0 +1,140 @@
+module iophy
+  
+  REAL,private,allocatable,dimension(:,:),save :: tmp_tab2d
+  REAL,private,allocatable,dimension(:,:,:),save :: tmp_tab3d
+  INTEGER,private,allocatable,dimension(:),save :: ndex2d
+  INTEGER,private,allocatable,dimension(:),save :: ndex3d
+  REAL,private,allocatable,dimension(:),save :: io_lat
+  REAL,private,allocatable,dimension(:),save :: io_lon
+  
+  INTERFACE histwrite_phy
+    MODULE PROCEDURE histwrite2d_phy,histwrite3d_phy
+  END INTERFACE 
+
+contains
+
+  subroutine init_iophy(lat,lon)
+  use dimphy
+  implicit none
+  include 'dimensions90.h'   
+    real,dimension(iim),intent(in) :: lon
+    real,dimension(jjm+1),intent(in) :: lat
+  
+    allocate(io_lat(jjm+1))
+    io_lat(:)=lat(:)
+    allocate(io_lon(iim))
+    io_lon(:)=lon(:)
+    allocate(tmp_tab2d(iim,jjphy_nb))
+    allocate(tmp_tab3d(iim,jjphy_nb,klev))
+    allocate(ndex2d(iim*jjphy_nb))
+    allocate(ndex3d(iim*jjphy_nb*klev))
+    ndex2d(:)=0
+    ndex3d(:)=0
+
+  end subroutine init_iophy
+  
+  subroutine histbeg_phy(name,itau0,zjulian,dtime,nhori,nid_day)
+  use dimphy
+  use ioipsl
+  use write_field
+  implicit none
+  include 'dimensions90.h'
+    
+    character*(*), intent(IN) :: name
+    integer, intent(in) :: itau0
+    real,intent(in) :: zjulian
+    real,intent(in) :: dtime
+    integer,intent(out) :: nhori
+    integer,intent(out) :: nid_day
+    
+    if (monocpu) then
+      call histbeg(name,iim,io_lon, jjphy_nb,io_lat(jjphy_begin:jjphy_end), &
+                   1,iim,1,jjphy_nb,itau0, zjulian, dtime, nhori, nid_day)
+    else
+      call histbeg(name//'_'//trim(int2str(phy_rank)),iim,io_lon, jjphy_nb,io_lat(jjphy_begin:jjphy_end), &
+                   1,iim,1,jjphy_nb,itau0, zjulian, dtime, nhori, nid_day)
+    endif
+  
+  end subroutine histbeg_phy
+  
+  subroutine histwrite2d_phy(nid,name,itau,field)
+  use dimphy
+  use ioipsl
+  implicit none
+  include 'dimensions90.h'
+    
+    integer,intent(in) :: nid
+    character*(*), intent(IN) :: name
+    integer, intent(in) :: itau
+    real,dimension(klon),intent(in) :: field
+    
+    CALL phy2dyn(field,tmp_tab2d,1)
+    CALL histwrite(nid,name,itau,tmp_tab2d,iim*jjphy_nb,ndex2d)
+    
+  end subroutine histwrite2d_phy
+  
+  subroutine histwrite3d_phy(nid,name,itau,field)
+  use dimphy
+  use ioipsl
+  implicit none
+  include 'dimensions90.h'
+    
+    integer,intent(in) :: nid
+    character*(*), intent(IN) :: name
+    integer, intent(in) :: itau
+    real,dimension(klon,klev),intent(in) :: field
+    
+    CALL phy2dyn(field,tmp_tab3d,klev)
+    CALL histwrite(nid,name,itau,tmp_tab3d,iim*jjphy_nb*klev,ndex3d)
+    
+  end subroutine histwrite3d_phy
+  
+  
+  subroutine phy2dyn(field_phy,field_dyn,nlev)
+  use dimphy
+  implicit none
+  include 'dimensions90.h'
+  
+    real,dimension(klon,nlev),intent(in) :: field_phy
+    real,dimension(iim,jjphy_nb,nlev),intent(out) :: field_dyn
+    integer,intent(in) :: nlev
+    
+    integer :: next
+    integer :: j,l
+    
+      do l=1,nlev
+        	
+	if (jjphy_begin==jjphy_end) then
+	  field_dyn(:,1,l)=0.
+	  field_dyn(iiphy_begin:iiphy_end,1,l)=field_phy(1:klon,l)
+	else
+	
+	 if (jjphy_begin==1) then
+	    field_dyn(:,1,l)=field_phy(1,l)
+	    next=2
+	 else
+	   field_dyn(:,1,l)=0.
+	   next=iim-iiphy_begin+1
+	   field_dyn(iiphy_begin:iim,1,l)=field_phy(1:next-1,l)   
+	 endif
+	
+	  do j=2,jjphy_nb-1
+	    field_dyn(:,j,l)=field_phy(next:next+iim-1,l)
+	    next=next+iim
+	  enddo
+	  
+	  if (jjphy_end==jjm+1) then
+             field_dyn(:,jjphy_nb,l)=field_phy(klon,l)
+	  else
+	   field_dyn(:,jjphy_nb,l)=0.
+	   field_dyn(1:iiphy_end,jjphy_nb,l)=field_phy(next:next+iiphy_end-1,l)   
+	  endif
+	  
+	endif
+     
+     enddo
+	 
+    end subroutine phy2dyn	    
+  
+	  
+end module iophy
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/newmicro.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/newmicro.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/newmicro.F	(revision 633)
@@ -193,5 +193,5 @@
      .           1.1 * ( (pqlwp(i,k) * pplay(i,k) / (RD * T(i,k)) )  
      .               / (4./3. * RPI * 1000. * cdnc_pi(i,k)) )**(1./3.)
-            radius = MAX(radius*1.e6, 3.) 
+            radius = MAX(radius*1.e6, 5.) 
             
             tc = t(i,k)-273.15
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/oasis.dummy
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/oasis.dummy	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/oasis.dummy	(revision 633)
@@ -20,7 +20,17 @@
 c     INCLUDE "param.h"
 c
-      INTEGER kastp, kexch, kstep,imjm
+      INTEGER kastp, kexch, kstep,imjm,klon
       INTEGER iparal(3)
       INTEGER ifcpl, idt, info, imxtag, istep, jf
+
+c -- LOOP
+c 
+#include "dimensions.h"
+      INTEGER jjmp1
+      PARAMETER (jjmp1=jjm+1-1/jjm)
+#include "dimphy.h"
+       REAL zwindsp(klon)
+c
+c -- LOOP
 c
 #include "param_cou.h"
@@ -72,27 +82,30 @@
 c         must be the same as (1) of the field  definition in namcouple:
 c
-      cl_writ(1)='COSHFICE'
-      cl_writ(2)='COSHFOCE'
-      cl_writ(3)='CONSFICE'
-      cl_writ(4)='CONSFOCE'
-      cl_writ(5)='CODFLXDT'
+      cl_writ(8)='COSHFICE'
+      cl_writ(9)='COSHFOCE'
+      cl_writ(10)='CONSFICE'
+      cl_writ(11)='CONSFOCE'
+      cl_writ(12)='CODFLXDT'
 c      cl_writ(6)='COICTEMP'
-      cl_writ(6)='COTFSICE'
-      cl_writ(7)='COTFSOCE'
-      cl_writ(8)='COTOLPSU'
-      cl_writ(9)='COTOSPSU'
-      cl_writ(10)='CORUNCOA'
-      cl_writ(11)='CORIVFLU'
-      cl_writ(12)='COCALVIN'
+      cl_writ(13)='COTFSICE'
+      cl_writ(14)='COTFSOCE'
+      cl_writ(15)='COTOLPSU'
+      cl_writ(16)='COTOSPSU'
+      cl_writ(17)='CORUNCOA'
+      cl_writ(18)='CORIVFLU'
+      cl_writ(19)='COCALVIN'
 c$$$      cl_writ(13)='COZOTAUX'
 c$$$      cl_writ(14)='COZOTAUV'
 c$$$      cl_writ(15)='COMETAUY'
 c$$$      cl_writ(16)='COMETAUU'
-      cl_writ(13)='COTAUXXU'
-      cl_writ(14)='COTAUYYU'
-      cl_writ(15)='COTAUZZU'
-      cl_writ(16)='COTAUXXV'
-      cl_writ(17)='COTAUYYV'
-      cl_writ(18)='COTAUZZV'
+      cl_writ(1)='COTAUXXU'
+      cl_writ(2)='COTAUYYU'
+      cl_writ(3)='COTAUZZU'
+      cl_writ(4)='COTAUXXV'
+      cl_writ(5)='COTAUYYV'
+      cl_writ(6)='COTAUZZV'
+c -- LOOP
+      cl_writ(7)='COWINDSP'
+c -- LOOP
 c
 c     Define files name for fields exchanged from atmos to coupler,
@@ -117,4 +130,7 @@
       cl_f_writ(17)='flxatmos'
       cl_f_writ(18)='flxatmos'
+c -- LOOP
+      cl_f_writ(19)='flxatmos'
+c -- LOOP
 
 c
@@ -310,8 +326,10 @@
 
 c $Id$
+c -- LOOP
       SUBROUTINE intocpl(kt, imjm, fsolice, fsolwat, fnsolice, fnsolwat,
      $    fnsicedt, evice, evwat, lpre, spre, dirunoff, rivrunoff, 
-     $    calving, tauxx_u, tauyy_u, tauzz_u, tauxx_v, tauyy_v, tauzz_v
-     $    , last) 
+     $    calving, tauxx_u, tauyy_u, tauzz_u, tauxx_v, tauyy_v, tauzz_v,
+     $    windsp, last)
+c -- LOOP 
 c ======================================================================
 c S. Valcke (02/99) adapted From L.Z.X Li: this subroutine provides the 
@@ -321,4 +339,16 @@
 c ======================================================================
       IMPLICIT NONE
+c -- LOOP
+c 
+#include "dimensions.h"
+      INTEGER jjmp1
+      PARAMETER (jjmp1=jjm+1-1/jjm)
+#include "dimphy.h"
+c      REAL zu10m(klon), zv10m(klon)
+       REAL zwindsp(klon)
+c
+c -- LOOP
+c
+
       INTEGER kt, imjm
 c
@@ -345,4 +375,7 @@
       REAL tauzz_u(imjm)
       REAL tauzz_v(imjm)
+c -- LOOP
+       REAL windsp(imjm)
+c -- LOOP
       LOGICAL last
 c
@@ -424,41 +457,41 @@
 c         WRITE fields to files          
           DO jf=1, jpflda2o1 + jpflda2o2
-            IF (jf.eq.1)
+            IF (jf.eq.8)
      $          CALL locwrite(cl_writ(jf),fsolice, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.2)
+            IF (jf.eq.9)
      $          CALL locwrite(cl_writ(jf),fsolwat, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.3)
+            IF (jf.eq.10)
      $          CALL locwrite(cl_writ(jf),fnsolice, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.4)
+            IF (jf.eq.11)
      $          CALL locwrite(cl_writ(jf),fnsolwat, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.5)
+            IF (jf.eq.12)
      $          CALL locwrite(cl_writ(jf),fnsicedt, imjm,
      $          file_unit_field(jf), ierror) 
-c            IF (jf.eq.6)
+c            IF (jf.eq.13)
 c     $          CALL locwrite(cl_writ(jf),ictemp, imjm,
 c     $          file_unit_field(jf), ierror) 
-            IF (jf.eq.6)
+            IF (jf.eq.13)
      $          CALL locwrite(cl_writ(jf),evice, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.7)
+            IF (jf.eq.14)
      $          CALL locwrite(cl_writ(jf),evwat, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.8)
+            IF (jf.eq.15)
      $          CALL locwrite(cl_writ(jf),lpre, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.9)
+            IF (jf.eq.16)
      $          CALL locwrite(cl_writ(jf),spre, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.10)
+            IF (jf.eq.17)
      $          CALL locwrite(cl_writ(jf),dirunoff, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.11)
+            IF (jf.eq.18)
      $          CALL locwrite(cl_writ(jf),rivrunoff, imjm,
      $          file_unit_field(jf), ierror) 
-            IF (jf.eq.12)
+            IF (jf.eq.19)
      $          CALL locwrite(cl_writ(jf),calving, imjm,
      $          file_unit_field(jf), ierror) 
@@ -475,22 +508,28 @@
 c$$$     $          CALL locwrite(cl_writ(jf),tauyu, imjm,
 c$$$     $          file_unit_field(jf), ierror) 
-            IF (jf.eq.13)
+            IF (jf.eq.1)
      $          CALL locwrite(cl_writ(jf),tauxx_u, imjm,
      $          file_unit_field(jf),ierror)
-            IF (jf.eq.14)
+            IF (jf.eq.2)
      $          CALL locwrite(cl_writ(jf),tauyy_u, imjm,
      $          file_unit_field(jf),ierror)
-            IF (jf.eq.15)
+            IF (jf.eq.3)
      $          CALL locwrite(cl_writ(jf),tauzz_u, imjm,
      $          file_unit_field(jf),ierror)
-            IF (jf.eq.16)
+            IF (jf.eq.4)
      $          CALL locwrite(cl_writ(jf),tauxx_v, imjm,
      $          file_unit_field(jf),ierror)
-            IF (jf.eq.17)
+            IF (jf.eq.5)
      $          CALL locwrite(cl_writ(jf),tauyy_v, imjm,
      $          file_unit_field(jf),ierror)
-            IF (jf.eq.18)
+            IF (jf.eq.6)
      $          CALL locwrite(cl_writ(jf),tauzz_v, imjm,
      $          file_unit_field(jf),ierror)
+c -- LOOP
+            IF (jf.eq.7)
+     $         CALL locwrite(cl_writ(jf),windsp, imjm,
+     $         file_unit_field(jf),ierror)
+c -- LOOP
+
           END DO 
 C
@@ -522,28 +561,30 @@
           DO jn=1, jpflda2o1 + jpflda2o2
 C            
-          IF (jn.eq.1) CALL CLIM_Export(cl_writ(jn), kt, fsolice, info)
-          IF (jn.eq.2) CALL CLIM_Export(cl_writ(jn), kt, fsolwat, info)
-          IF (jn.eq.3) CALL CLIM_Export(cl_writ(jn), kt, fnsolice, info)
-          IF (jn.eq.4) CALL CLIM_Export(cl_writ(jn), kt, fnsolwat, info)
-          IF (jn.eq.5) CALL CLIM_Export(cl_writ(jn), kt, fnsicedt, info)
+          IF (jn.eq.8) CALL CLIM_Export(cl_writ(jn), kt, fsolice, info)
+          IF (jn.eq.9) CALL CLIM_Export(cl_writ(jn), kt, fsolwat, info)
+         IF (jn.eq.10) CALL CLIM_Export(cl_writ(jn), kt, fnsolice, info)
+         IF (jn.eq.11) CALL CLIM_Export(cl_writ(jn), kt, fnsolwat, info)
+         IF (jn.eq.12) CALL CLIM_Export(cl_writ(jn), kt, fnsicedt, info)
 c          IF (jn.eq.6) CALL CLIM_Export(cl_writ(jn), kt, ictemp, info)
-          IF (jn.eq.6) CALL CLIM_Export(cl_writ(jn), kt, evice, info)
-          IF (jn.eq.7) CALL CLIM_Export(cl_writ(jn), kt, evwat, info)
-          IF (jn.eq.8) CALL CLIM_Export(cl_writ(jn), kt, lpre, info)
-          IF (jn.eq.9) CALL CLIM_Export(cl_writ(jn), kt, spre, info)
-          IF (jn.eq.10) CALL CLIM_Export(cl_writ(jn),kt,dirunoff, info)
-          IF (jn.eq.11) CALL CLIM_Export(cl_writ(jn),kt,rivrunoff,info)
-          IF (jn.eq.12) CALL CLIM_Export(cl_writ(jn),kt,calving,info)
+          IF (jn.eq.13) CALL CLIM_Export(cl_writ(jn), kt, evice, info)
+          IF (jn.eq.14) CALL CLIM_Export(cl_writ(jn), kt, evwat, info)
+          IF (jn.eq.15) CALL CLIM_Export(cl_writ(jn), kt, lpre, info)
+          IF (jn.eq.16) CALL CLIM_Export(cl_writ(jn), kt, spre, info)
+          IF (jn.eq.17) CALL CLIM_Export(cl_writ(jn),kt,dirunoff, info)
+          IF (jn.eq.18) CALL CLIM_Export(cl_writ(jn),kt,rivrunoff,info)
+          IF (jn.eq.19) CALL CLIM_Export(cl_writ(jn),kt,calving,info)
 c$$$          IF (jn.eq.13) CALL CLIM_Export(cl_writ(jn), kt, tauxu, info)
 c$$$          IF (jn.eq.14) CALL CLIM_Export(cl_writ(jn), kt, tauxv, info)
 c$$$          IF (jn.eq.15) CALL CLIM_Export(cl_writ(jn), kt, tauyv, info)
 c$$$          IF (jn.eq.16) CALL CLIM_Export(cl_writ(jn), kt, tauyu, info)
-          IF (jn.eq.13) CALL CLIM_Export(cl_writ(jn), kt, tauxx_u, info)
-          IF (jn.eq.14) CALL CLIM_Export(cl_writ(jn), kt, tauyy_u, info)
-          IF (jn.eq.15) CALL CLIM_Export(cl_writ(jn), kt, tauzz_u, info)
-          IF (jn.eq.16) CALL CLIM_Export(cl_writ(jn), kt, tauxx_v, info)
-          IF (jn.eq.17) CALL CLIM_Export(cl_writ(jn), kt, tauyy_v, info)
-          IF (jn.eq.18) CALL CLIM_Export(cl_writ(jn), kt, tauzz_v, info)
-          
+          IF (jn.eq.1) CALL CLIM_Export(cl_writ(jn), kt, tauxx_u, info)
+          IF (jn.eq.2) CALL CLIM_Export(cl_writ(jn), kt, tauyy_u, info)
+          IF (jn.eq.3) CALL CLIM_Export(cl_writ(jn), kt, tauzz_u, info)
+          IF (jn.eq.4) CALL CLIM_Export(cl_writ(jn), kt, tauxx_v, info)
+          IF (jn.eq.5) CALL CLIM_Export(cl_writ(jn), kt, tauyy_v, info)
+          IF (jn.eq.6) CALL CLIM_Export(cl_writ(jn), kt, tauzz_v, info)
+c -- LOOP
+          IF (jn.eq.7) CALL CLIM_Export(cl_writ(jn), kt, windsp, info)
+c -- LOOP          
             IF (info .NE. CLIM_Ok) THEN
                 WRITE (nuout,*) 'STEP : Pb giving ',cl_writ(jn), ':',jn
